package mysql

import (
	"context"
	"fmt"
	"gorm.io/gen"
	"pji_desktop_http/biz/dal/query"
	"pji_desktop_http/biz/model"
)

func AddOriginalMapOneRecord(ctx context.Context, record model.OriginalMap) error {
	r := query.OriginalMap
	err := r.WithContext(ctx).Create(&record)
	return err
}

func UpdateOriginalMapOneRecord(ctx context.Context, record model.OriginalMap) (gen.ResultInfo, error) {
	r := query.OriginalMap
	fmt.Println("record update", record)
	info, err := r.WithContext(ctx).Where(r.ID.Eq(record.ID)).Updates(record)
	if err != nil {
		return info, err
	}
	return info, nil
}

func QueryOriginalMapByMapIdAndDeviceNo(ctx context.Context, mapId string, deviceNo string) ([]*model.OriginalMap, error) {
	r := query.OriginalMap
	originalMaps, err := r.WithContext(ctx).Where(r.MapID.Eq(mapId), r.DeviceNo.Eq(deviceNo)).Find()
	if err != nil {
		return nil, err
	}
	return originalMaps, nil
}

func QueryOriginalMapWithoutCicvMap(ctx context.Context) ([]*model.OriginalMap, error) {
	r := query.OriginalMap
	originalMaps, err := r.WithContext(ctx).Where(r.CicvMapZipURL.Null()).Or(r.CicvMapPgmURL.Null()).Find()
	if err != nil {
		return nil, err
	}
	return originalMaps, nil
}
